#!/usr/bin/perl

#┌─────────────────────────────────
#│ TOPICS BOARD : admin.cgi - 2021/07/25
#│ copyright (c) kentweb, 1997-2021
#│ https://www.kent-web.com/
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  NEWS BOOK v1.5 : admin.cgi - 2023/08/06
#│  Edited by TRANSFORM Since 2012
#│  https://www.transformsite.com/
#└─────────────────────────────────
# モジュール宣言
use strict;
use CGI::Carp qw(fatalsToBrowser);
use vars qw(%in %cf);
use lib "./lib";
use CGI::Minimal;
use CGI::Session;
use Digest::SHA::PurePerl qw(sha256_base64);

# 設定ファイル認識
require "./init.cgi";
%cf = set_init();

# データ受理
CGI::Minimal::max_read_size($cf{maxdata});
my $cgi = CGI::Minimal->new;
error('容量オーバー') if ($cgi->truncated);
%in = parse_form($cgi);

# 認証
require "./lib/login.pl";
auth_login();

# 処理分岐
if ($in{data_new}) { data_new(); }
if ($in{data_men}) { data_men(); }
if ($in{pass_mgr}) { pass_mgr(); }
if ($in{apprv_log}) { apprv_log(); }
if ($in{mente_com}) { mente_com(); }
if ($in{set_prof}) { set_prof(); }

# メニュー画面
menu_html();

#-----------------------------------------------------------
#  メニュー画面
#-----------------------------------------------------------
sub menu_html {
	header("メニューTOP");
	
	print <<EOM;
<div id="main">
<div align="center">
<p>選択ボタンを押してください。</p>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<table class="menu-tbl">
<tr>
	<th>&nbsp;</th>
	<th width="280">処理メニュー</th>
</tr><tr>
	<td><input type="submit" name="data_new" value="選択"></td>
	<td>新規記事作成</td>
</tr><tr>
	<td><input type="submit" name="data_men" value="選択"></td>
	<td>記事メンテナンス（修正・削除）</td>
EOM

	if ($cf{approve} == 1) {
		print qq|</tr><tr>\n|;
		print qq|<td><input type="submit" name="apprv_log" value="選択"></td>\n|;
		print qq|<td>コメントの承認/反映</td>\n|;
	}

	print <<EOM;
</tr><tr>
	<td><input type="submit" name="mente_com" value="選択"></td>
	<td>コメントメンテナンス（修正・削除）</font></td>
EOM

	if ($cf{prof} == 1) {
		print qq|</tr><tr>\n|;
		print qq|<td><input type="submit" name="set_prof" value="選択"></td>\n|;
		print qq|<td>プロフィール設定</td>\n|;
	}

	print <<EOM;
</tr><tr>
	<td><input type="submit" name="pass_mgr" value="選択"></td>
	<td>パスワード管理</td>
</tr><tr>
	<td><input type="button" value="選択" onclick="javascript:window.location='$cf{bbs_cgi}'"></td>
	<td>ログアウト（掲示板移動）</td>
</tr>
</table>
</form>
</div></div>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  新規記事
#-----------------------------------------------------------
sub data_new {
	$in{tag} = 1;
	
	# 新規作成実行
	if ($in{job} eq 'new2') { add_data(); }
	
	# 編集時
	my $log = shift;
	my ($no,$y,$m,$d,$time,$sub,$com,$e1,$w1,$h1,$e2,$w2,$h2,$e3,$w3,$h3,$tag,$att,$tube,$e4,$w4,$h4,$e5,$w5,$h5,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$cm) = split(/<>/,$log);
	$com =~ s/\t/\n/g;
	$com =~ s|<br( /)?>|\n|g;
	
	# 添付
	my %chk;
	if ($att eq 't') {
		$chk{y} = "checked";
		$chk{i} = "";
	} else {
		$chk{y} = "";
		$chk{i} = "checked";
	}
	
	# パラメータ定義
	my $job = $in{job} ? "edit2" : "new2";
	
	# 新規投稿時は年月日を取得
	my ($hidden,$md);
	if ($in{data_new}) {
		my ($min,$hr,$day,$mon,$yr) = (localtime(time))[1..5];
		$y = $yr + 1900;
		$m = sprintf("%02d",$mon+1);
		$d = sprintf("%02d",$day);
		$time = sprintf("%02d:%02d",$hr,$min);
		$hidden = qq|<input type="hidden" name="data_new" value="1">|;
	} else {
		$hidden = qq|<input type="hidden" name="data_men" value="1">|;
		$md = 'data_men';
	}
	
	# フォーム表示
	header("投稿フォーム","js");
	print <<EOM;
<div id="main">
EOM

	back_btn($md);

	if ($in{data_men}) {
		print qq|<br /><div class="ttl"> 編集フォーム</div>\n|;
	} else {
		print qq|<br /><div class="ttl"> 投稿フォーム</div>\n|;
	}
	print <<EOM;
<ul>
<li>ファイルのアップロードまたはYouTubeタグ（ニコ動画等も可）を貼り付けることができます（任意）。
</ul>
<form action="$cf{admin_cgi}" method="post" enctype="multipart/form-data">
<input type="hidden" name="sid" value="$in{sid}">
$hidden
<input type="hidden" name="ym" value="$in{ym}">
<input type="hidden" name="job" value="$job">
<input type="hidden" name="no" value="$no">
<table class="form-tbl">
<tr>
	<th class="w-item">年月日</th>
	<td>
EOM

	if ($in{data_men}) {
		my ($yr,$mon) = $in{ym} =~ /^(\d+)-(\d+)/ && ($1,$2);
		print qq|$yr年 $mon月\n|;
	} else {
		print qq|<input type="text" name="y" value="$y" size="4"> 年\n|;
		print qq|<select name="m">\n|;
		for my $i (1 .. 12) {
			$i = sprintf("%02d",$i);
			if ($m == $i) {
				print qq |<option value="$i" selected>$i\n|;
			} else {
				print qq |<option value="$i">$i\n|;
			}
		}
		print qq|</select> 月\n|;
	}
	
	print qq|<select name="d">\n|;
	
	for my $i (1 .. 31) {
		$i = sprintf("%02d",$i);
		if ($d == $i) {
			print qq |<option value="$i" selected>$i\n|;
		} else {
			print qq |<option value="$i">$i\n|;
		}
	}
	
	print <<EOM;
		</select> 日
		&nbsp; 時刻：<input type="text" name="time" value="$time" size="8">
	</td>
</tr><tr>
	<th class="w-item">件名</th>
	<td><input type="text" name="sub" value="$sub" size="40"></td>
</tr><tr>
	<th class="w-item">本文</th>
	<td>
		<input type="checkbox" onclick="toggleHtmlEditor(this.checked,'myArea3','full')">エディタ起動<br>
		<textarea name="comment" style="width:700px;height:400px;" id="myArea3">$com</textarea>
	</td>
</tr><tr>
	<th class="w-item">貼付種別</th>
	<td>
		<input type="radio" name="clip" value="i" onclick="entryChange1();" $chk{i}>ファイルアップ
		<input type="radio" name="clip" value="t" onclick="entryChange1();" $chk{y}>YouTube
	</td>
</tr><tr id="ibox">
	<th class="w-item">ファイル<br>アップ</th>
	<td nowrap>

	<div id="image_point02">
		<div class="imgview001" id="preview1"></div>
		<div class="imgview002" id="preview2"></div>
		<div class="imgview003" id="preview3"></div>
		<div class="imgview004" id="preview4"></div>
		<div class="imgview005" id="preview5"></div>
	</div>
	<div class="clear"></div>
EOM

	my %e = (1 => $e1, 2 => $e2, 3 => $e3, 4 => $e4, 5 => $e5);
	my %imgtxt = (1 => $imgtxt1, 2 => $imgtxt2, 3 => $imgtxt3, 4 => $imgtxt4, 5 => $imgtxt5);
	for my $i (1 .. 5) {
		print qq|添付$i : <input type="file" name="upfile$i" id="upload$i" size="40">\n|;
		print qq|<input type="text" name="imgtext$i" class="reg-imgtxt" placeholder="添付$iタイトル" value="$imgtxt{$i}" size="40">\n|;

		if ($e{$i}) {
			print qq|&nbsp;<input type="checkbox" name="del$i" value="1">削除\n|;
			print qq|[<a href="$cf{uplurl}/$no-$i$e{$i}" target="_blank">添付</a>]\n|;
		}
		print "<br>\n";
	}
	
	print <<EOM;
	</td>
</tr><tr id="ybox">
	<th class="w-item">YouTube<br>タグ</th>
	<td><textarea name="tube" cols="60" rows="8">$tube</textarea></td>
</tr><tr>
	<th>コメント機能</th>
	<td>
EOM

	my %ox = (1 => '受け入れる', 0 => '受け入れない');
	for (1,0) {
		if ($cm == $_) {
			print qq|<input type="radio" name="cm" value="$_" checked>$ox{$_}\n|;
		} else {
			print qq|<input type="radio" name="cm" value="$_">$ox{$_}\n|;
		}
	}

	print <<EOM;
	</td>
</tr><tr>
	<th class="w-item"></th>
	<td><input type="submit" value="送信する"></td>
</tr>
</table>
</form>
EOM

	nic_edit();
	
	print <<EOM;
</div></div>
</body>
</html>
EOM
	# フッタ
	footer();

	exit;
}

#-----------------------------------------------------------
#  プロフィール設定
#-----------------------------------------------------------
sub set_prof {
	my %set = read_profile();
	$set{profile} =~ s/\t/\n/g;
	
	# --- 更新
	if ($in{submit}) {
		
		# 画像削除
		if ($in{imgdel} == 1) {
			unlink("$cf{upldir}/$set{prof_image}");
			$in{prof_image} = "";
			$set{prof_image} = "";
		}
		
		# 画像アップ
		if ($in{upfile1}) {
			my ($ex,$w,$h) = prof_upload("prof");
			if ($ex) {
				if ($set{prof_image} && $set{prof_image} ne "prof-1$ex") {
					unlink("$cf{upldir}/$set{prof_image}");
				}
				$in{prof_image} = "prof-1" . $ex;
			} else {
				$in{prof_image} = "";
			}
		} else {
			$in{prof_image} = $set{prof_image};
		}
		
		$in{profile} =~ s/(<br>)+$//;
		
		# ファイル上書き
		my @log;
		for (qw(prof_image prof_img_w profile)) {
			push(@log,"$_<>$in{$_}\n");
		}
		open(DAT,"> $cf{datadir}/profile.dat");
		print DAT @log;
		close(DAT);
		
		# 完了メッセージ
		message("プロフィール設定を更新しました");
	}
	
	header("プロフィール設定");
	print <<EOM;
<div id="body">
<div class="back-btn">
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="submit" value="&lt; メニュー">
</form>
</div>
<div class="ttl"> プロフィール設定</div>
<form action="$cf{admin_cgi}" method="post" enctype="multipart/form-data">
<input type="hidden" name="sid" value="$in{sid}">
<input type="hidden" name="set_prof" value="1">
<table class="prof-tbl">
<tr>
	<th>プロフィール画像</th>
	<td>
  		【最大幅】<input type="tel" name="prof_img_w" size="3" value="$set{prof_img_w}"> pix
  		（これを超えると自動縮小）<br>
  		<input type="file" name="upfile1" size="30">
EOM

	# トップ画像
	if ($set{prof_image}) {
		print qq |<input type="checkbox" name="imgdel" value="1">削除\n|;
		print qq |[<a href="$cf{uplurl}/$set{prof_image}" target="_blank">画像</a>]\n|;
	}
	
	print <<EOM;
  </td>
</tr><tr>
	<th>プロフィール</th>
	<td><textarea name="profile" cols="60" rows="2">$set{profile}</textarea></td>
</tr><tr>
	<th></th>
	<td><input type="submit" name="submit" value="送信する" class="big-btn"></td>
</tr>
</table>
</form>
</div>
</body>
</html>
EOM
	exit;
}

#-----------------------------------------------------------
#  nicEdit定義
#-----------------------------------------------------------
sub nic_edit {
	print <<'EOM';
<script>
var html_editor = new Array();
var html_editor_loaded = false;
function loadHtmlEditor() {
	if (!html_editor_loaded) {
		var scripts = document.getElementsByTagName('script');
		for (var i=0; i<scripts.length; i++) {
			if (scripts[i].src.search(/nicEdit\.js$/) != -1) return true;
		}
		var header = document.getElementsByTagName('head')[0];
		var loader = document.createElement('script');
		loader.setAttribute('type','text/javascript');
EOM

	# パス指定
	print qq|loader.setAttribute('src','$cf{cmnurl}/nicEdit.js');\n|;

	print <<'EOM';
		header.appendChild(loader);
		html_editor_loaded = true;
	}
}
function updateHtmlEditor(this_id) {
	if (html_editor[this_id] != null) {
		html_editor[this_id].updateInstance(this_id);
	}
}
function toggleHtmlEditor(open,this_id,panel_type) {
	if (open) {
		if (typeof nicEditor == "undefined") {
			loadHtmlEditor();
			setTimeout(function() { toggleHtmlEditor(open,this_id,panel_type) },500);
		} else {
			if (html_editor[this_id] == null) html_editor[this_id] = new nicEditor({panelType : panel_type}).panelInstance(this_id);
		}
	} else if (html_editor[this_id] != null) {
		html_editor[this_id].removeInstance(this_id);
		html_editor[this_id] = null;
	}
}
</script>
EOM
}

#-----------------------------------------------------------
#  記事メンテナンス
#-----------------------------------------------------------
sub data_men {
	$in{tag} = 1;
	
	# 修正フォーム
	if ($in{job} eq "edit" && $in{no}) {

		my $log;
		open(DAT,"$cf{datadir}/log/$in{ym}.dat");
		while(<DAT>) {
			my ($no) = (split(/<>/))[0];
			
			if ($in{no} == $no) {
				chomp;
				$log = $_;
				last;
			}
		}
		close(DAT);

		open(IN,"$cf{datadir}/index.dat");
		while (<IN>) {
			my ($no,$date,$sub,$com,$e1,$w1,$h1,$e2,$w2,$h2,$e3,$w3,$h3,$tag,$att,$tube,$e4,$w4,$h4,$e5,$w5,$h5,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$cm) = split(/<>/);
			if ($in{no} == $no) {
				$log = $_;
				last;
			}
		}
		close(IN);
		
		# 修正画面
		data_new($log);
	
	# 修正実行
	} elsif ($in{job} eq "edit2" && $in{no}) {
		
		$in{tube} =~ s|<br( /)?>||g;
		
		# 画像アップ
		my ($e1n,$w1n,$h1n,$e2n,$w2n,$h2n,$e3n,$w3n,$h3n,$e4n,$w4n,$h4n,$e5n,$w5n,$h5n);
		if ($in{upfile1} || $in{upfile2} || $in{upfile3} || $in{upfile4} || $in{upfile5}) {
			($e1n,$w1n,$h1n,$e2n,$w2n,$h2n,$e3n,$w3n,$h3n,$e4n,$w4n,$h4n,$e5n,$w5n,$h5n) = upload($in{no});
		}
		
		my ($flg,$chg,@sort,@data);
		open(DAT,"+< $cf{datadir}/log/$in{ym}.dat") or die;
		while(<DAT>) {
			my ($no,$y,$m,$d,$time,$sub,$com,$e1,$w1,$h1,$e2,$w2,$h2,$e3,$w3,$h3,$tag,$att,$tube,$e4,$w4,$h4,$e5,$w5,$h5,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$cm) = split(/<>/);
			
			if ($in{no} == $no) {

				# 画像削除のとき
				if ($in{del1}) {
					unlink("$cf{upldir}/$no-1$e1");
					unlink("$cf{upldir}/$no-s-1$e1") if (-f "$cf{upldir}/$no-s-1$e1");
					$e1 = $w1 = $h1 = "";
				}
				if ($in{del2}) {
					unlink("$cf{upldir}/$no-2$e2");
					unlink("$cf{upldir}/$no-s-2$e2") if (-f "$cf{upldir}/$no-s-2$e2");
					$e2 = $w2 = $h2 = "";
				}
				if ($in{del3}) {
					unlink("$cf{upldir}/$no-3$e3");
					unlink("$cf{upldir}/$no-s-3$e3") if (-f "$cf{upldir}/$no-s-3$e3");
					$e3 = $w3 = $h3 = "";
				}
				if ($in{del4}) {
					unlink("$cf{upldir}/$no-4$e4");
					unlink("$cf{upldir}/$no-s-4$e4") if (-f "$cf{upldir}/$no-s-4$e4");
					$e4 = $w4 = $h4 = "";
				}
				if ($in{del5}) {
					unlink("$cf{upldir}/$no-5$e5");
					unlink("$cf{upldir}/$no-s-5$e5") if (-f "$cf{upldir}/$no-s-5$e5");
					$e5 = $w5 = $h5 = "";
				}
				# 画像差替（拡張子が異なる場合）
				if ($e1n && $e1n ne $e1) {
					unlink("$cf{upldir}/$no-1$e1");
					unlink("$cf{upldir}/$no-s-1$e1") if (-f "$cf{upldir}/$no-s-1$e1");
				}
				if ($e2n && $e2n ne $e2) {
					unlink("$cf{upldir}/$no-2$e2");
					unlink("$cf{upldir}/$no-s-2$e2") if (-f "$cf{upldir}/$no-s-2$e2");
				}
				if ($e3n && $e3n ne $e3) {
					unlink("$cf{upldir}/$no-3$e3");
					unlink("$cf{upldir}/$no-s-3$e3") if (-f "$cf{upldir}/$no-s-3$e3");
				}
				if ($e4n && $e4n ne $e4) {
					unlink("$cf{upldir}/$no-4$e4");
					unlink("$cf{upldir}/$no-s-4$e4") if (-f "$cf{upldir}/$no-s-4$e4");
				}
				if ($e5n && $e5n ne $e5) {
					unlink("$cf{upldir}/$no-5$e5");
					unlink("$cf{upldir}/$no-s-5$e5") if (-f "$cf{upldir}/$no-s-5$e5");
				}
				
				# 画像差替
				if ($e1n) { $e1 = $e1n; $w1 = $w1n; $h1 = $h1n; }
				if ($e2n) { $e2 = $e2n; $w2 = $w2n; $h2 = $h2n; }
				if ($e3n) { $e3 = $e3n; $w3 = $w3n; $h3 = $h3n; }
				if ($e4n) { $e4 = $e4n; $w4 = $w4n; $h4 = $h4n; }
				if ($e5n) { $e5 = $e4n; $w4 = $w5n; $h5 = $h5n; }
				
				$d = $in{d};
				$time = $in{time};
				
				$_ = "$no<>$y<>$m<>$d<>$time<>$in{sub}<>$in{comment}<>$e1<>$w1<>$h1<>$e2<>$w2<>$h2<>$e3<>$w3<>$h3<>$in{tag}<>$in{clip}<>$in{tube}<>$e4<>$w4<>$h4<>$e5<>$w5<>$h5<>$in{imgtext1}<>$in{imgtext2}<>$in{imgtext3}<>$in{imgtext4}<>$in{imgtext5}<>$in{cm}<>\n";
			}
			$time =~ s/\D//g;
			push(@sort,"$d$time");
			push(@data,$_);
		}
		
		# ソート
		@data = @data[sort{$sort[$b] <=> $sort[$a]} 0 .. $#sort];
		
		# 更新
		seek(DAT,0,0);
		print DAT @data;
		truncate(DAT,tell(DAT));
		close(DAT);

		my @file;
		open(DAT,"+< $cf{datadir}/index.dat");
		while (<DAT>) {
			chomp;
			my ($no,$y,$m,$d,$time,$sub,$com,$e1,$w1,$h1,$e2,$w2,$h2,$e3,$w3,$h3,$tag,$clip,$tube,$e4,$w4,$h4,$e5,$w5,$h5,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$cm) = split(/<>/);
			
			if ($in{no} == $no) {
				
				# 画像削除のとき
				if ($in{del1}) {
					unlink("$cf{upldir}/$no-1$e1");
					unlink("$cf{upldir}/$no-s-1$e1") if (-f "$cf{upldir}/$no-s-1$e1");
					$e1 = $w1 = $h1 = "";
				}
				if ($in{del2}) {
					unlink("$cf{upldir}/$no-2$e2");
					unlink("$cf{upldir}/$no-s-2$e2") if (-f "$cf{upldir}/$no-s-2$e2");
					$e2 = $w2 = $h2 = "";
				}
				if ($in{del3}) {
					unlink("$cf{upldir}/$no-3$e3");
					unlink("$cf{upldir}/$no-s-3$e3") if (-f "$cf{upldir}/$no-s-3$e3");
					$e3 = $w3 = $h3 = "";
				}
				if ($in{del4}) {
					unlink("$cf{upldir}/$no-4$e4");
					unlink("$cf{upldir}/$no-s-4$e4") if (-f "$cf{upldir}/$no-s-4$e4");
					$e4 = $w4 = $h4 = "";
				}
				if ($in{del5}) {
					unlink("$cf{upldir}/$no-5$e5");
					unlink("$cf{upldir}/$no-s-5$e5") if (-f "$cf{upldir}/$no-s-5$e5");
					$e5 = $w5 = $h5 = "";
				}
				# 画像差替（拡張子が異なる場合）
				if ($e1n && $e1n ne $e1) {
					unlink("$cf{upldir}/$no-1$e1");
					unlink("$cf{upldir}/$no-s-1$e1") if (-f "$cf{upldir}/$no-s-1$e1");
				}
				if ($e2n && $e2n ne $e2) {
					unlink("$cf{upldir}/$no-2$e2");
					unlink("$cf{upldir}/$no-s-2$e2") if (-f "$cf{upldir}/$no-s-2$e2");
				}
				if ($e3n && $e3n ne $e3) {
					unlink("$cf{upldir}/$no-3$e3");
					unlink("$cf{upldir}/$no-s-3$e3") if (-f "$cf{upldir}/$no-s-3$e3");
				}
				if ($e4n && $e4n ne $e4) {
					unlink("$cf{upldir}/$no-4$e4");
					unlink("$cf{upldir}/$no-s-4$e4") if (-f "$cf{upldir}/$no-s-4$e4");
				}
				if ($e5n && $e5n ne $e5) {
					unlink("$cf{upldir}/$no-5$e5");
					unlink("$cf{upldir}/$no-s-5$e5") if (-f "$cf{upldir}/$no-s-5$e5");
				}
				
				# 画像差替
				if ($e1n) { $e1 = $e1n; $w1 = $w1n; $h1 = $h1n; }
				if ($e2n) { $e2 = $e2n; $w2 = $w2n; $h2 = $h2n; }
				if ($e3n) { $e3 = $e3n; $w3 = $w3n; $h3 = $h3n; }
				if ($e4n) { $e4 = $e4n; $w4 = $w4n; $h4 = $h4n; }
				if ($e5n) { $e5 = $e4n; $w4 = $w5n; $h5 = $h5n; }
				
				$d = $in{d};
				$time = $in{time};
				
				$_ = "$no<>$y<>$m<>$d<>$time<>$in{sub}<>$in{comment}<>$e1<>$w1<>$h1<>$e2<>$w2<>$h2<>$e3<>$w3<>$h3<>$in{tag}<>$in{clip}<>$in{tube}<>$e4<>$w4<>$h4<>$e5<>$w5<>$h5<>$in{imgtext1}<>$in{imgtext2}<>$in{imgtext3}<>$in{imgtext4}<>$in{imgtext5}<>$in{cm}<>";
			}
			push(@file,"$_\n");
		}
		seek(DAT,0,0);
		print DAT @file;
		truncate(DAT,tell(DAT));
		close(DAT);

		# 完了画面
		message('記事を修正しました','data_men');

	# 削除
	} elsif ($in{job} eq "dele" && $in{no}) {

		# 削除情報
		my %del;
		for ( $cgi->param('no') ) {
			$del{$_}++;
		}
		
		# 年月別ログオープン
		my (@data,%chg);
		open(DAT,"+< $cf{datadir}/log/$in{ym}.dat");
		while(<DAT>) {
			my ($no,$y,$m,$d,$time,$sub,$com,$e1,$w1,$h1,$e2,$w2,$h2,$e3,$w3,$h3,$tag,$clip,$tube,$e4,$w4,$h4,$e5,$w5,$h5,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$cm) = split(/<>/);
			
			# 削除対象
			if (defined $del{$no}) {
				if ($e1) {
					unlink("$cf{upldir}/$no-1$e1");
					unlink("$cf{upldir}/$no-s-1$e1") if (-f "$cf{upldir}/$no-s-1$e1");
				}
				if ($e2) {
					unlink("$cf{upldir}/$no-2$e2");
					unlink("$cf{upldir}/$no-s-2$e2") if (-f "$cf{upldir}/$no-s-2$e2");
				}
				if ($e3) {
					unlink("$cf{upldir}/$no-3$e3");
					unlink("$cf{upldir}/$no-s-3$e3") if (-f "$cf{upldir}/$no-s-3$e3");
				}
				if ($e4) {
					unlink("$cf{upldir}/$no-4$e4");
					unlink("$cf{upldir}/$no-s-4$e4") if (-f "$cf{upldir}/$no-s-4$e4");
				}
				if ($e5) {
					unlink("$cf{upldir}/$no-5$e5");
					unlink("$cf{upldir}/$no-s-5$e5") if (-f "$cf{upldir}/$no-s-5$e5");
				}
				next;
			}
			push(@data,$_);
		}
		
		# 年月別ログ更新
		seek(DAT,0,0);
		print DAT @data;
		truncate(DAT,tell(DAT));
		close(DAT);

		# indexログオープン
		open(DAT,"+< $cf{datadir}/index.dat");
		while (<DAT>) {
			my ($no,$y,$m,$d,$time,$sub,$com,$e1,$w1,$h1,$e2,$w2,$h2,$e3,$w3,$h3,$tag,$att,$tube,$e4,$w4,$h4,$e5,$w5,$h5,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$cm) = split(/<>/);

			# 削除対象
			if (defined $del{$no}) {
				if ($e1) {
					unlink("$cf{upldir}/$no-1$e1");
					unlink("$cf{upldir}/$no-s-1$e1") if (-f "$cf{upldir}/$no-s-1$e1");
				}
				if ($e2) {
					unlink("$cf{upldir}/$no-2$e2");
					unlink("$cf{upldir}/$no-s-2$e2") if (-f "$cf{upldir}/$no-s-2$e2");
				}
				if ($e3) {
					unlink("$cf{upldir}/$no-3$e3");
					unlink("$cf{upldir}/$no-s-3$e3") if (-f "$cf{upldir}/$no-s-3$e3");
				}
				if ($e4) {
					unlink("$cf{upldir}/$no-4$e4");
					unlink("$cf{upldir}/$no-s-4$e4") if (-f "$cf{upldir}/$no-s-4$e4");
				}
				if ($e5) {
					unlink("$cf{upldir}/$no-5$e5");
					unlink("$cf{upldir}/$no-s-5$e5") if (-f "$cf{upldir}/$no-s-5$e5");
				}
				next;
			}
			push(@data,$_);
		}
		seek(DAT,0,0);
		print DAT @data;
		truncate(DAT,tell(DAT));
		close(DAT);

		# コメントログオープン
		my @file;
		open(DAT,"+< $cf{reslog}") or error("open err: $cf{reslog}");
		while (<DAT>) {

			my ($no,$ent,$sub,$date,$name,$url,$host,$com,$e1,$w1,$h1,$e2,$w2,$h2,$e3,$w3,$h3,$chk,$pw,$comsub) = split(/<>/);

			if ($in{no} == $ent) {

				# 画像削除
				if ($e1) { 
					unlink("$cf{r_upldir}/$no-1$e1");
					unlink("$cf{r_upldir}/$no-s-1$e1") if (-f "$cf{r_upldir}/$no-s-1$e1");
				}
				if ($e2) { 
					unlink("$cf{r_upldir}/$no-2$e2");
					unlink("$cf{r_upldir}/$no-s-2$e2") if (-f "$cf{r_upldir}/$no-s-2$e2");
				}
				if ($e3) { 
					unlink("$cf{r_upldir}/$no-3$e3");
					unlink("$cf{r_upldir}/$no-s-3$e3") if (-f "$cf{r_upldir}/$no-s-3$e3");
				}
				next;
			}
			push(@file,$_);
		}

		# 返信ログ更新
		seek(DAT, 0, 0);
		print DAT @file;
		truncate(DAT, tell(DAT));
		close(DAT);

		# 連番修正
		open(DAT,"+< $cf{resnum}");
		eval "flock(DAT, 2);";
		my $num = <DAT> - 1;
		seek(DAT, 0, 0);
		print DAT $num;
		truncate(DAT, tell(DAT));
		close(DAT);

		# 年月を分解
		my ($yr,$mon) = split(/-/,$in{ym});

		# 年月書庫
		my @file;
		open(DAT,"+< $cf{datadir}/archive.dat");
		while(<DAT>) {
			my ($y,$m,$cnt) = split(/,/);
			
			if ($yr == $y && $mon == $m) {
				
				# データが空のときは行を削除
				next if (@file == 0);
				
				chomp;
				$cnt--;
				$_ = "$y,$m,$cnt\n";
			}
			push(@file,$_);
		}
		seek(DAT,0,0);
		print DAT @file;
		truncate(DAT,tell(DAT));
		close(DAT);

		# TOPレスカウント更新
		top_rescnt();

		# 採番
		open(DAT,"+< $cf{datadir}/num.dat");
		my $num = <DAT> - 1;
		seek(DAT,0,0);
		print DAT $num;
		truncate(DAT,tell(DAT));
		close(DAT);

		# 完了画面
		message('記事を削除しました','data_men');
	
	# ソート
	} elsif ($in{job} eq "sort") {
		
		my (@sort,@data);
		open(DAT,"+< $cf{datadir}/index.dat");
		while (<DAT>) {
			my ($no,$y,$m,$d,$time,$sub,$com,$e1,$w1,$h1,$e2,$w2,$h2,$e3,$w3,$h3,$tag,$clip,$tube,$e4,$w4,$h4,$e5,$w5,$h5,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$cm) = split(/<>/);
			
			push(@sort,$in{"sort:$no"});
			push(@data,$_);
		}
		
		# ソート
		@data = @data[sort {$sort[$a] <=> $sort[$b]} 0 .. $#sort];
		
		# 更新
		seek(DAT,0,0);
		print DAT @data;
		truncate(DAT,tell(DAT));
		close(DAT);
	}
	
	header("メニュー &gt; 記事メンテナンス");
	print <<"EOM";
<div id="main">
EOM
	back_btn();
	print <<"EOM";
<br />
<div class="ttl"> 記事メンテナンス</div>
<ul>
<li>処理を選択して送信ボタンを押してください。
<li>並び替えは「ソ\ート」を選択し、順番の数字を変更して送信ボタンを押してください。
</ul>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="hidden" name="data_men" value="1">

年月：
<select name="ym">
EOM

	# 書庫indexオープン
	open(DAT,"$cf{datadir}/archive.dat");
	
	# 年月パラメータがないときはデータのトップを初期値とする
	if (!$in{ym}) {
		my $top = <DAT>;
		my ($y,$m,$cnt) = split(/,/,$top);
		
		$in{ym} = "$y-$m";
		
		# TOPに巻き戻す
		seek(DAT,0,0);
	}
	
	while(<DAT>) {
		chomp;
		my ($y,$m,$cnt) = split(/,/);
		
		if ($in{ym} eq "$y-$m") {
			print qq |<option value="$y-$m" selected>$y年$m月\n|;
		} else {
			print qq |<option value="$y-$m">$y年$m月\n|;
		}
	}
	close(DAT);
	
	print <<EOM;
</select>
<input type="submit" name="chg" value="切替">
<p>
処理：
<select name="job">
<option value="edit">修正
<option value="sort">ソート
<option value="dele">削除
</select>
<input type="submit" value="送信する">
</p>
<table class="edit-tbl">
<tr>
  <th nowrap>選択</th>
  <th nowrap>順番</th>
  <th nowrap>タイトル</th>
  <th nowrap>日付</th>
  <th nowrap>添付</th>
</tr>
EOM

	# ログ展開
	my $i = 0;
	open(IN,"$cf{datadir}/log/$in{ym}.dat");
	while (<IN>) {
		my ($no,$y,$m,$d,$time,$sub,$com,$e1,$w1,$h1,$e2,$w2,$h2,$e3,$w3,$h3,$tag,$clip,$tube,$e4,$w4,$h4,$e5,$w5,$h5,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$cm) = split(/<>/);
		$i++;
		
		print qq|<tr><td class="ta-c"><input type="radio" name="no" value="$no"></td>|;
		print qq|<td><input type="text" name="sort:$no" value="$i" size="3"></td>|;
		print qq|<td><b>$sub</b></td>|;
		print qq|<td nowrap>$y/$m/$d $time</td><td>|;
		print qq|[<a href="$cf{uplurl}/$no-1$e1" target="_blank">1</a>]\n| if ($e1);
			if ($imgtxt1 eq '' && $e1) {
				print qq|<span style="color:#d83473">no title</span> &nbsp;<br>\n|;
			} elsif ($imgtxt1) {
				print qq|<span style="color:#d83473">($imgtxt1)</span> &nbsp;<br>\n|;
			}

		print qq|[<a href="$cf{uplurl}/$no-2$e2" target="_blank">2</a>]\n| if ($e2);
			if ($imgtxt2 eq '' && $e2) {
				print qq|<span style="color:#d83473">no title</span> &nbsp;<br>\n|;
			} elsif ($imgtxt2) {
				print qq|<span style="color:#d83473">($imgtxt2)</span> &nbsp;<br>\n|;
			}

		print qq|[<a href="$cf{uplurl}/$no-3$e3" target="_blank">3</a>]\n| if ($e3);
			if ($imgtxt3 eq '' && $e3) {
				print qq|<span style="color:#d83473">no title</span> &nbsp;<br>\n|;
			} elsif ($imgtxt3) {
				print qq|<span style="color:#d83473">($imgtxt3)</span> &nbsp;<br>\n|;
			}

		print qq|[<a href="$cf{uplurl}/$no-4$e4" target="_blank">4</a>]\n| if ($e4);
			if ($imgtxt4 eq '' && $e4) {
				print qq|<span style="color:#d83473">no title</span> &nbsp;<br>\n|;
			} elsif ($imgtxt4) {
				print qq|<span style="color:#d83473">($imgtxt4)</span> &nbsp;<br>\n|;
			}

		print qq|[<a href="$cf{uplurl}/$no-5$e5" target="_blank">5</a>]\n| if ($e5);
			if ($imgtxt5 eq '' && $e5) {
				print qq|<span style="color:#d83473">no title</span> &nbsp;<br>\n|;
			} elsif ($imgtxt5) {
				print qq|<span style="color:#d83473">($imgtxt5)</span> &nbsp;<br>\n|;
			}
		print qq|<br></td></tr>\n|;
	}
	close(IN);
	
	print <<EOM;
</table>
</form>
</div></div>
</body>
</html>
EOM
	# フッタ
	footer();

	exit;
}

#-----------------------------------------------------------
#  記事追加
#-----------------------------------------------------------
sub add_data {
	# 入力チェック
	input_check();
	$in{tube} =~ s|<br( /)?>||g;
	
	# indexデータオープン
	my ($num,@file,@data);
	open(DAT,"+< $cf{datadir}/index.dat");
	while (<DAT>) {
		my ($no) = (split(/<>/))[0];
		
		if ($num < $no) { $num = $no; }
		push(@file,$_);
	}
	
	# 採番
	$num++;
	
	# 画像アップ
	my ($e1,$w1,$h1,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5)
			= $in{upfile1} || $in{upfile2} || $in{upfile3} || $in{upfile4} || $in{upfile5} ? upload($num) : ();
	
	# 最大記事数調整
	while ( $cf{max} - 1 <= @file ) {
		my $del = pop(@file);
		my ($no,$y,$m,$d,$time,$sub,$com,$e1,$w1,$h1,$e2,$w2,$h2,$e3,$w3,$h3,$tag,$clip,$tube,$e4,$w4,$h4,$e5,$w5,$h5,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$cm) = split(/<>/,$del);
		if ($e1) {
			unlink("$cf{upldir}/$no-1$e1");
			unlink("$cf{upldir}/$no-s-1$e1") if (-f "$cf{upldir}/$no-s-1$e1");
		}
		if ($e2) {
			unlink("$cf{upldir}/$no-2$e2");
			unlink("$cf{upldir}/$no-s-2$e2") if (-f "$cf{upldir}/$no-s-2$e2");
		}
		if ($e3) {
			unlink("$cf{upldir}/$no-3$e3");
			unlink("$cf{upldir}/$no-s-3$e3") if (-f "$cf{upldir}/$no-s-3$e3");
		}
		if ($e4) {
			unlink("$cf{upldir}/$no-4$e4");
			unlink("$cf{upldir}/$no-s-4$e4") if (-f "$cf{upldir}/$no-s-4$e4");
		}
		if ($e5) {
			unlink("$cf{upldir}/$no-5$e5");
			unlink("$cf{upldir}/$no-s-5$e5") if (-f "$cf{upldir}/$no-s-5$e5");
		}
	}
	
	# 更新
	unshift(@file,"$num<>$in{y}<>$in{m}<>$in{d}<>$in{time}<>$in{sub}<>$in{comment}<>$e1<>$w1<>$h1<>$e2<>$w2<>$h2<>$e3<>$w3<>$h3<>$in{tag}<>$in{clip}<>$in{tube}<>$e4<>$w4<>$h4<>$e5<>$w5<>$h5<>$in{imgtext1}<>$in{imgtext2}<>$in{imgtext3}<>$in{imgtext4}<>$in{imgtext5}<>$in{cm}<>\n");
	seek(DAT,0,0);
	print DAT @file;
	truncate(DAT,tell(DAT));
	close(DAT);

		if (!-e "$cf{datadir}/log/$in{y}-$in{m}.dat") {
			open(DAT,"> $cf{datadir}/log/$in{y}-$in{m}.dat");
			close(DAT);
			
			chmod(0666,"$cf{datadir}/log/$in{y}-$in{m}.dat");
		}
		
		# 採番
		open(DAT,"+< $cf{datadir}/num.dat");
		my $num = <DAT> + 1;
		seek(DAT,0,0);
		print DAT $num;
		truncate(DAT,tell(DAT));
		close(DAT);
		
		# 月次ログ更新
		my (@sort,@data);
		open(DAT,"+< $cf{datadir}/log/$in{y}-$in{m}.dat");
		while(<DAT>) {
			my ($no,$y,$m,$d,$time,$sub,$com,$e1,$w1,$h1,$e2,$w2,$h2,$e3,$w3,$h3,$tag,$clip,$tube,$e4,$w4,$h4,$e5,$w5,$h5,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$cm) = split(/<>/);
			
			$time =~ s/\D//g;
			push(@sort,"$d$time");
			push(@data,$_);
		}
		
		my $time = $in{time};
		$time =~ s/\D//g;
		
		unshift(@sort,"$in{d}$time");
		unshift(@data,"$num<>$in{y}<>$in{m}<>$in{d}<>$in{time}<>$in{sub}<>$in{comment}<>$e1<>$w1<>$h1<>$e2<>$w2<>$h2<>$e3<>$w3<>$h3<>$in{tag}<>$in{clip}<>$in{tube}<>$e4<>$w4<>$h4<>$e5<>$w5<>$h5<>$in{imgtext1}<>$in{imgtext2}<>$in{imgtext3}<>$in{imgtext4}<>$in{imgtext5}<>$in{cm}<>\n");
		
		# ソート
		@data = @data[sort{$sort[$b] <=> $sort[$a]} 0 .. $#sort];
		
		# 更新
		seek(DAT,0,0);
		print DAT @data;
		truncate(DAT,tell(DAT));
		close(DAT);

		# 年月書庫
		@data = ();
		my $flg;
		open(DAT,"+< $cf{datadir}/archive.dat");
		while(<DAT>) {
			my ($y,$m,$cnt) = split(/,/);

			if ($in{y} == $y && $in{m} == $m) {
				$flg++;
				
				chomp $cnt;
				$cnt++;
				$_ = "$y,$m,$cnt\n";
			}
			push(@data,$_);
		}
		
		# 新規年月の場合
		if (!$flg) {
			
			# ソートするため再度展開
			my (@jun,@log);
			for (@data) {
				my ($y,$m,$cnt) = split(/,/);
				
				push(@jun,"$y$m");
				push(@log,$_);
			}
			
			# 新規データ追加
			push(@jun,"$in{y}$in{m}");
			push(@log,"$in{y},$in{m},1\n");

			# ソート
			@data = @log[sort{$jun[$b] <=> $jun[$a]} 0 .. $#jun];
		}
		
		seek(DAT,0,0);
		print DAT @data;
		truncate(DAT,tell(DAT));
		close(DAT);

	# 完了
	message("新規書き込みを完了しました");
}

#-----------------------------------------------------------
#  コメント返信の承認・反映
#-----------------------------------------------------------
sub apprv_log {
	# 承認
	if ($in{job} eq 'aprv' && $in{no}) {

		my @data;
		foreach ( split(/\0/, $in{no}) ) {
			open(IN,"$cf{logdir}/$_.cgi");
			my $log = <IN>;
			close(IN);

			push(@data,$log);
		}

	# 連番読み込み
	open(DAT,"+< $cf{resnum}");
	eval "flock(DAT, 2);";
	my $number = <DAT>;
	seek(DAT, 0, 0);
	print DAT $number;
	truncate(DAT, tell(DAT));
	close(DAT);

		my @log;
		open(DAT,"+< $cf{reslog}") or cgi_err("open err: $cf{reslog}");
		eval "flock(DAT, 2);";
		while (<DAT>) {
			my ($no,$ent,$sub,$date,$name,$url,$host,$com,$e1,$w1,$h1,$e2,$w2,$h2,$e3,$w3,$h3,$chk,$pw,$comsub) = split(/<>/);
				push(@log,$_);
		}

		foreach (@data) {
			unshift(@log,"$number<>$_\n");
		}

		# 更新
		seek(DAT, 0, 0);
		print DAT @log;
		truncate(DAT, tell(DAT));
		close(DAT);

	# TOPレスカウント更新
	top_rescnt();

		# 一時ファイル削除
		foreach ( split(/\0/,$in{no}) ) {
			unlink("$cf{logdir}/$_.cgi");
		}

	# 削除
	} elsif ($in{job} eq 'dele' && $in{no}) {
		foreach ( split(/\0/,$in{no}) ) {
			unlink("$cf{logdir}/$_.cgi");
		}
	}

	# クッキー格納
	set_cookie($in{name},$in{url}) if ($in{cookie});

	# コメント返信の承認/反映画面を表示
	header("コメント返信の承認/反映");

	print <<EOM;
<div id="main">
EOM
	back_btn();
	print <<EOM;
<br />
<div class="sub-ttl"> コメント返信の承認/反映</div>
<ul>
<li>「承認」又は「削除」を選択して送信ボタンを押してください。やり直しはできないので慎重に！
</ul>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="apprv_log" value="1">
<input type="hidden" name="sid" value="$in{sid}">
処理：
<select name="job">
<option value="aprv">承認
<option value="dele">削除
</select>
<input type="submit" value="送信する">
EOM

	opendir(DIR,"$cf{logdir}");
	while( $_ = readdir(DIR) ) {
		next if (!/^(\d+)\.cgi$/);

		my $num = $1;
		open(IN,"$cf{logdir}/$num.cgi");
		my $log = <IN>;
		close(IN);

		my ($ent,$sub,$date,$name,$url,$host,$com,$e1,$w1,$h1,$e2,$w2,$h2,$e3,$w3,$h3,$chk,$pw,$comsub) = split(/<>/,$log);

		print qq|<div class="art"><input type="checkbox" name="no" value="$num">\n|;
		print qq|<strong>$comsub</strong> 投稿者：<b>$name</b> 投稿日：$date [ <span>$host</span> ]\n|;
		print qq|<div class="com">$com</div>\n|;
		if ($e1) {
			my $size = get_size("$cf{r_upldir}/$num-1$e1");
			print qq|<dd>添付|;
			print qq|：<a href="$cf{r_uplurl}/$num-1$e1" target="_blank">$num-1$e1</a> ($size)\n|;
		}
		if ($e2) {
			my $size = get_size("$cf{r_upldir}/$num-2$e2");
			print qq|<dd>添付|;
			print qq|：<a href="$cf{r_uplurl}/$num-2$e2" target="_blank">$num-2$e2</a> ($size)\n|;
		}
		if ($e3) {
			my $size = get_size("$cf{r_upldir}/$num-3$e3");
			print qq|<dd>添付|;
			print qq|：<a href="$cf{r_uplurl}/$num-3$e3" target="_blank">$num-3$e3</a> ($size)\n|;
		}
		print qq|</div>\n|;
	}
	closedir(DIR);

	print <<EOM;
</form>
<hr class="bottom">
</div></div>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-------------------------------------------------
#  コメント返信メンテナンス
#-------------------------------------------------
sub mente_com {

	# ページ数
	my $page = $in{page} || '0';
	foreach ( $cgi->param() ) {
		if (/^page:(\d+)$/) {
			$page = $1;
			last;
		}
	}

	# 削除処理
	if ($in{job} eq "dele" && $in{no}) {

		# 削除情報
		my %del;
		foreach ( split(/\0/, $in{no}) ) {
			$del{$_} = 1;
		}

		# コメントログオープン
		my @data;
		open(DAT,"+< $cf{reslog}") or error("open err: $cf{reslog}");
		while (<DAT>) {

			my ($no,$ent,$sub,$date,$name,$url,$host,$com,$e1,$w1,$h1,$e2,$w2,$h2,$e3,$w3,$h3,$chk,$pw,$comsub) = split(/<>/);

			if (defined($del{$no})) {

				# 画像削除
				if ($e1) { 
					unlink("$cf{r_upldir}/$no-1$e1");
					unlink("$cf{r_upldir}/$no-s-1$e1") if (-f "$cf{r_upldir}/$no-s-1$e1");
				}
				if ($e2) { 
					unlink("$cf{r_upldir}/$no-2$e2");
					unlink("$cf{r_upldir}/$no-s-2$e2") if (-f "$cf{r_upldir}/$no-s-2$e2");
				}
				if ($e3) { 
					unlink("$cf{r_upldir}/$no-3$e3");
					unlink("$cf{r_upldir}/$no-s-3$e3") if (-f "$cf{r_upldir}/$no-s-3$e3");
				}
				next;
			}
			push(@data,$_);
		}

		# 返信ログ更新
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

		# 完了メッセージ
		message("記事を削除しました");

		# 連番修正
		open(DAT,"+< $cf{resnum}");
		eval "flock(DAT, 2);";
		my $num = <DAT> - 1;
		seek(DAT, 0, 0);
		print DAT $num;
		truncate(DAT, tell(DAT));
		close(DAT);

	# TOP用レスカウント更新
	top_rescnt();

	# 修正処理
	} elsif ($in{job} eq "edit" && $in{no}) {

		my @data;
		open(IN,"+< $cf{reslog}");
		while (<IN>) {
			my ($no,$ent,$sub,$date,$name,$url,$host,$com,$e1,$w1,$h1,$e2,$w2,$h2,$e3,$w3,$h3,$chk,$pw,$comsub) = split(/<>/);

			if ($in{no} == $no) {
				@data = ($no,$ent,$sub,$date,$name,$url,$host,$com,$e1,$w1,$h1,$e2,$w2,$h2,$e3,$w3,$h3,$chk,$pw,$comsub);
				last;
			}
		}
		close(IN);

		# 修正画面
		data_com(@data);

	# 修正実行
	} elsif ($in{job} eq "edit2" && $in{no}) {

		# 入力値補正
		if ($in{url} eq 'http://') { $in{url} = ''; }

		# 画像アップ
		my ($e1n,$w1n,$h1n,$e2n,$w2n,$h2n,$e3n,$w3n,$h3n);
		if ($in{upfile1} || $in{upfile2} || $in{upfile3}) {
			($e1n,$w1n,$h1n,$e2n,$w2n,$h2n,$e3n,$w3n,$h3n) = res_upload($in{no});
		}

		my @data;
		open(DAT,"+< $cf{reslog}");
		while (<DAT>) {
			chomp;
			my ($no,$ent,$sub,$date,$name,$url,$host,$com,$e1,$w1,$h1,$e2,$w2,$h2,$e3,$w3,$h3,$chk,$pw,$comsub) = split(/<>/);

			if ($in{no} == $no) {

				# 画像削除のとき
				if ($in{del1}) {
					unlink("$cf{r_upldir}/$no-1$e1");
					unlink("$cf{r_upldir}/$no-s-1$e1") if (-f "$cf{r_upldir}/$no-s-1$e1");
					$e1 = $w1 = $h1 = "";
				}
				if ($in{del2}) {
					unlink("$cf{r_upldir}/$no-2$e2");
					unlink("$cf{r_upldir}/$no-s-2$e2") if (-f "$cf{r_upldir}/$no-s-2$e2");
					$e2 = $w2 = $h2 = "";
				}
				if ($in{del3}) {
					unlink("$cf{r_upldir}/$no-3$e3");
					unlink("$cf{r_upldir}/$no-s-3$e3") if (-f "$cf{r_upldir}/$no-s-3$e3");
					$e3 = $w3 = $h3 = "";
				}
				# 画像差替（拡張子が異なる場合）
				if ($e1n && $e1n ne $e1) {
					unlink("$cf{r_upldir}/$no-1$e1");
					unlink("$cf{r_upldir}/$no-s-1$e1") if (-f "$cf{r_upldir}/$no-s-1$e1");
				}
				if ($e2n && $e2n ne $e2) {
					unlink("$cf{r_upldir}/$no-2$e2");
					unlink("$cf{r_upldir}/$no-s-2$e2") if (-f "$cf{r_upldir}/$no-s-2$e2");
				}
				if ($e3n && $e3n ne $e3) {
					unlink("$cf{r_upldir}/$no-3$e3");
					unlink("$cf{r_upldir}/$no-s-3$e3") if (-f "$cf{r_upldir}/$no-s-3$e3");
				}

				# 画像差替
				if ($e1n) { $e1 = $e1n; $w1 = $w1n; $h1 = $h1n; }
				if ($e2n) { $e2 = $e2n; $w2 = $w2n; $h2 = $h2n; }
				if ($e3n) { $e3 = $e3n; $w3 = $w3n; $h3 = $h3n; }

				$_ = "$no<>$ent<>$in{sub}<>$date<>$in{name}<>$in{url}<>$host<>$in{comment}<>$e1<>$w1<>$h1<>$e2<>$w2<>$h2<>$e3<>$w3<>$h3<>0<>$pw<>$in{comsub}<>";
			}
			push(@data,"$_\n");
		}

		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

		# 完了メッセージ
		message("コメントを修正しました");

	}

	header("管理メニュー &gt; コメント返信（修正/削除）");
	print <<"EOM";
<div id="main">
EOM
	back_btn();
	print <<"EOM";
<br />
<div class="ttl"> コメント返信（修正/削除）</div>
<blockquote>
<font size="-1">
<li>処理を選択して送信ボタンを押してください。
</ul>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="hidden" name="mente_com" value="1">
処理：
<select name="job">
<option value="edit">修正
<option value="dele">削除
</select>
<input type="submit" value="送信する" class="small button" />
</blockquote>
<table class="edit-fm">
<tr>
  <th><font size="-1">選択</font></th>
  <th>[No.] 返信投稿日時</th>
  <th>親記事タイトル(投稿日)</th>
  <th>返信投稿者</th>
  <th>返信タイトル</th>
  <th>コメント</th>
</tr>
EOM

	# 記事
	my %sub;
	open(IN,"$cf{datadir}/index.dat");
	while (<IN>) {
		my ($no,$y,$m,$d,$time,$sub,$com,$e1,$w1,$h1,$e2,$w2,$h2,$e3,$w3,$h3,$tag,$att,$tube,$ex4,$w4,$h4,$ex5,$w5,$h5,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$cm) = split(/<>/);
			$sub{$no} = "<b style=\"color:#ed6d46\">$sub</b> (<span style=\"color:#a688bd\">$y/$m/$d</span>)";
	}
	close(IN);

	# コメント返信
	my @log;
	my $i = 0;
	open(IN,"$cf{reslog}");
	my @data = <IN>;
	close(IN);
	@data = reverse(@data);

	foreach(@data) {
		$i++;
		next if ($i < $page + 1);
		next if ($i > $page + $cf{pg_max});

	push(@log,$_);
	}

	foreach (@log) {
		my ($no,$ent,$sub,$date,$name,$url,$host,$com,$e1,$w1,$h1,$e2,$w2,$h2,$e3,$w3,$h3,$chk,$pw,$comsub) = split(/<>/);

		#if (length($com) > 35) { $com = substr($com,0,40); $com .= '.....(略)'; }

		print qq |<tr><td width="30px"><input type="checkbox" name="no" value="$no"></td>|;
		print qq |<td width="240px">[$no] <font color="green">$date</font></td>|;
		print qq |<td width="350px">$sub{$ent}</td>|;
		print qq |<td width="120px"><p align="right"><font color="#de82a7">$name</font></p></td>|;
		print qq |<td width="240px">$comsub</td>|;
		print qq |<td width="470px"><div class="com">$com</div>|;
		print qq |<div class="ext">|;

	my %e = (1 => $e1, 2 => $e2, 3 => $e3);
	foreach my $n (1 .. 3) {
		if ($e{$n}) {
		print qq|添付($n) : |;
			my $size = get_size("$cf{r_upldir}/$no-$n$e{$n}");
			print qq |<a href="$cf{r_uplurl}/$no-$n$e{$n}" target="_blank">$no-$n$e{$n}</a> ($size)|;
			}
			print "<br />\n";
		}
		print qq |</div></td></tr>\n|;
	}

	if ($i == 0) {
		print qq |<td align="center" colspan="5"><font size="-1">コメント返信がありません</font></td>|;
	}
		print qq |</table>\n|;

	my $next = $page + $cf{pg_max};
	my $back = $page - $cf{pg_max};

	if ($back >= 0) {
		print qq|<input type="submit" name="page:$back" value="前画面" class="small button" /><br /><br />\n|;
	}
	if ($next < $i) {
		print qq|<input type="submit" name="page:$next" value="次画面" class="small button" /><br /><br />\n|;
	}

	print <<EOM;
</div></div>
</form>
</body></html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  コメント編集フォーム
#-----------------------------------------------------------
sub data_com {
	my ($no,$ent,$sub,$date,$name,$url,$host,$com,$e1,$w1,$h1,$e2,$w2,$h2,$e3,$w3,$h3,$chk,$pw,$comsub) = @_;

	$com =~ s/\t/\n/g;
	$url ||= 'http://';

	my $resmd = 'mente_res';

	header('管理TOP &gt; コメント編集フォーム');
	print <<EOM;
<div id="main">
EOM
	back_btn('mente_com');
	print <<EOM;
<br />
<div class="ttl"> 管理TOP &gt; コメント編集フォーム</div>
<br />
<form action="$cf{admin_cgi}" method="post" enctype="multipart/form-data" name="selform">
<input type="hidden" name="sid" value="$in{sid}">
<input type="hidden" name="mente_com" value="1">
<input type="hidden" name="job" value="edit2">
<input type="hidden" name="no" value="$no">
<table class="tbl-menu">
<tr>
	<th>Name</th>
	<td><input type="text" name="name" size="30" class="reg-name" value="$name"></td>
</tr><tr>
	<th>Website</th>
	<td><input type="text" name="url" size="30" class="reg-url" value="$url"></td>
</tr><tr>
	<th>Subject</th>
	<td><input type="text" name="comsub" size="36"class="reg-sub" value="$comsub"></td>
</tr><tr>
	<th>Comment</th>
	<td>
	<textarea name="comment" rows="7">$com</textarea>
	</td>
</tr><tr>
	<th>Attach</th>
	<td width="650">
	<div id="image_point">
		<div class="imgview001" id="preview1"></div>
		<div class="imgview002" id="preview2"></div>
		<div class="imgview003" id="preview3"></div>
	</div>
	<div class="clear"></div>
EOM

		if ($e1) {
			print qq|添付1 : <input type="file" name="upfile1" id="upload1" size="40">\n|;
			print qq|&nbsp;<input type="checkbox" name="del1" value="1">削除\n|;
			print qq|[<a href="$cf{r_uplurl}/$no-1$e1" target="_blank">添付</a>]\n|;
		} else {
			print qq|添付1 : <input type="file" name="upfile1" id="upload1" size="40">\n|;
		}
		print "<br />\n";
		if ($e2) {
			print qq|添付2 : <input type="file" name="upfile2" id="upload2" size="40">\n|;
			print qq|&nbsp;<input type="checkbox" name="del2" value="1">削除\n|;
			print qq|[<a href="$cf{r_uplurl}/$no-2$e2" target="_blank">添付</a>]\n|;
		} else {
			print qq|添付2 : <input type="file" name="upfile2" id="upload2" size="40">\n|;
		}
		print "<br />\n";
		if ($e3) {
			print qq|添付3 : <input type="file" name="upfile3" id="upload3" size="40">\n|;
			print qq|&nbsp;<input type="checkbox" name="del3" value="1">削除\n|;
			print qq|[<a href="$cf{r_uplurl}/$no-3$e3" target="_blank">添付</a>]\n|;
		} else {
			print qq|添付3 : <input type="file" name="upfile3" id="upload3" size="40">\n|;
		}
		print "<br />\n";

	print <<"EOM";
	</td>
</tr>
</table>
<br>
<input type="submit" value="編集する">
</form>
</div></div>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-------------------------------------------------
#  TOP用レスカウント更新
#-------------------------------------------------
sub top_rescnt {

	# コメントログ
	my (%res, @data);
	open(DB,"$cf{reslog}");
	while( my $db = <DB> ) {
		my ($no,$ent,$sub,$date,$name,$url,$host,$com,$e1,$w1,$h1,$e2,$w2,$h2,$e3,$w3,$h3,$chk,$pw,$comsub) = split(/<>/, $db);
		$res{$ent}++;
	}
	close(DB);

	# 記事ログ
	open(DB,"$cf{datadir}/index.dat");
	while( my $db = <DB> ) {
		chomp($db);
		my ($no,$y,$m,$d,$time,$sub,$com,$ex1,$w1,$h1,$ex2,$w2,$h2,$ex3,$w3,$h3,$tag,$att,$tube,$ex4,$w4,$h4,$ex5,$w5,$h5,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$cm) = split(/<>/, $db);

		if (!defined($res{$no})) { $res{$no} = 0; }
		push(@data,"$no<>$y<>$m<>$d<>$res{$no}<>\n");

	}
	close(DB);

	# index更新
	open(DAT,"+< $cf{rescnt}");
	eval "flock(DAT, 2);";
	seek(DAT, 0, 0);
	print DAT @data;
	truncate(DAT, tell(DAT));
	close(DAT);
}

#-----------------------------------------------------------
#  画像アップロード
#-----------------------------------------------------------
sub upload {
	my $no = shift;
	
	# サムネイル機能
	require './lib/thumb.pl' if ($cf{thumbnail});
	
	my @ret;
	for my $i (1 .. 5) {
		# 拡張子取得
		my $ext;
		if ($cgi->param_filename("upfile$i") =~ /(\.\w+)$/i) {
			$ext = $1;
		} else {
			push(@ret,('','',''));
			next;
		}
		$ext =~ tr/A-Z/a-z/;
		if ($ext eq '.jpeg') { $ext = '.jpg'; }
		
		# 添付ファイル定義
		my $upfile = "$cf{upldir}/$no-$i$ext";
		
		# アップロード書き込み
		open(UP,"> $upfile") or error("up err: $upfile");
		binmode(UP);
		print UP $in{"upfile$i"};
		close(UP);
		
		# パーミッション付与
		chmod(0666,$upfile);
		
		# 画像の場合サイズ取得
		my ($flg,$w,$h);
		if ($ext eq ".jpg") { ($w,$h) = j_size($upfile); $flg++; }
		elsif ($ext eq ".gif") { ($w,$h) = g_size($upfile); $flg++; }
		elsif ($ext eq ".png") { ($w,$h) = p_size($upfile); $flg++; }
		
		# サムネイル作成
		if ($flg && $cf{thumbnail}) {
			($w,$h) = resize($w,$h);
			my $thumb = "$cf{upldir}/$no-s-$i$ext";
			make_thumb($upfile,$thumb,$w,$h);
		}
		
		# 拡張子, 横幅, 縦幅 の順
		push(@ret,($ext,$w,$h));
	}
	# 結果を返す
	return @ret;
}

#-----------------------------------------------------------
#  コメント画像アップロード
#-----------------------------------------------------------
sub res_upload {
	my $no = shift;

	# サムネイル機能
	require './lib/thumb.pl' if ($cf{thumbnail});

	my @ret;
	foreach my $i (1 .. 3) {
		# 拡張子取得
		my $ext;
		if ($cgi->param_filename("upfile$i") =~ /(\.\w+)$/i) {
			$ext = $1;
		} else {
			push(@ret,('','',''));
			next;
		}
		$ext =~ tr/A-Z/a-z/;
		if ($ext eq '.jpeg') { $ext = '.jpg'; }

		# 添付ファイル定義
		my $upfile = "$cf{r_upldir}/$no-$i$ext";

		# アップロード書き込み
		open(UP,"+> $upfile") or error("up err: $upfile");
		binmode(UP);
		print UP $in{"upfile$i"};
		close(UP);

		# パーミッション付与
		chmod(0666,$upfile);

		# 画像の場合サイズ取得
		my ($flg,$w,$h);
		if ($ext eq ".jpg") { ($w,$h) = j_size($upfile); $flg++; }
		elsif ($ext eq ".gif") { ($w,$h) = g_size($upfile); $flg++; }
		elsif ($ext eq ".png") { ($w,$h) = p_size($upfile); $flg++; }

		# サムネイル作成
		if ($flg && $cf{thumbnail}) {
			($w,$h) = resize($w,$h);
			my $thumb = "$cf{r_upldir}/$no-s-$i$ext";
			make_thumb($upfile,$thumb,$w,$h);
		}

		# 拡張子, 横幅, 縦幅 の順
		push(@ret,($ext,$w,$h));
	}
	# 結果を返す
	return @ret;
}

#-----------------------------------------------------------
#  プロフィール画像アップロード
#-----------------------------------------------------------
sub prof_upload {
	my $no = shift;
	
	my @ret;
	for my $i (1 .. 3) {
		
		# mimeタイプ
		my $mime = $cgi->param_mime("upfile$i");
		
		# ファイル名
		my $fname = $cgi->param_filename("upfile$i");
		if ($fname =~ /(\.jpe?g|\.png|\.gif)$/i) {
			my $ex = $1;
			$ex =~ tr/A-Z/a-z/;
			if ($ex eq '.jpeg') { $ex = '.jpg'; }
			
			# 整合性チェック
			unless (($mime =~ /^image\/gif$/i and $ex eq '.gif') or ($mime =~ /^image\/p?jpe?g$/i and $ex eq '.jpg') or ($mime =~ /^image\/(x-)?png$/i and $ex eq '.png')) {
				push(@ret,('','',''));
				next;
			}
			
			# アップファイル定義
			my $imgfile = "$cf{upldir}/$no-$i$ex";
			
			# 書き込み
			open(OUT,"> $imgfile") or error("画像アップ失敗");
			binmode(OUT);
			print OUT $in{"upfile$i"};
			close(OUT);
			
			# パーミッション変更
			chmod(0666,$imgfile);
			
			# 画像サイズ取得
			my ($w,$h);
			if ($ex eq ".jpg") { ($w,$h) = j_size($imgfile); }
			elsif ($ex eq ".gif") { ($w,$h) = g_size($imgfile); }
			elsif ($ex eq ".png") { ($w,$h) = p_size($imgfile); }
			
			push(@ret,($ex,$w,$h));
		} else {
			push(@ret,('','',''));
		}
	}
	# 返り値
	return @ret;
}

#-----------------------------------------------------------
#  JPEGサイズ認識
#-----------------------------------------------------------
sub j_size {
	my $jpg = shift;
	
	my ($h, $w, $t);
	open(IMG,"$jpg");
	binmode(IMG);
	read(IMG, $t, 2);
	while (1) {
		read(IMG, $t, 4);
		my ($m, $c, $l) = unpack("a a n", $t);
		
		if ($m ne "\xFF") {
			$w = $h = 0;
			last;
		} elsif ((ord($c) >= 0xC0) && (ord($c) <= 0xC3)) {
			read(IMG, $t, 5);
			($h, $w) = unpack("xnn", $t);
			last;
		} else {
			read(IMG, $t, ($l - 2));
		}
	}
	close(IMG);
	
	return ($w,$h);
}

#-----------------------------------------------------------
#  GIFサイズ認識
#-----------------------------------------------------------
sub g_size {
	my $gif = shift;
	
	my $data;
	open(IMG,"$gif");
	binmode(IMG);
	sysread(IMG, $data, 10);
	close(IMG);
	
	if ($data =~ /^GIF/) { $data = substr($data, -4); }
	my $w = unpack("v", substr($data, 0, 2));
	my $h = unpack("v", substr($data, 2, 2));
	
	return ($w,$h);
}

#-----------------------------------------------------------
#  PNGサイズ認識
#-----------------------------------------------------------
sub p_size {
	my $png = shift;
	
	my $data;
	open(IMG,"$png");
	binmode(IMG);
	read(IMG, $data, 24);
	close(IMG);
	
	my $w = unpack("N", substr($data, 16, 20));
	my $h = unpack("N", substr($data, 20, 24));
	
	return ($w,$h);
}

#-----------------------------------------------------------
#  HTMLヘッダー
#-----------------------------------------------------------
sub header {
	my ($ttl,$js) = @_;
	
	print <<EOM;
Content-type: text/html; charset=utf-8

<!DOCTYPE html>
<html lang="ja">
<head>
<meta charset="utf-8">
<link href="$cf{cmnurl}/admin.css" rel="stylesheet">
<link href="https://use.fontawesome.com/releases/v5.6.1/css/all.css" rel="stylesheet">
<script type="text/javascript" src="./cmn/footerFixed_modified.js"></script>
<script type="text/javascript" src="./cmn/jquery-1.10.1.min.js"></script>
<script type="text/javascript" src="./cmn/jquery.uploadThumbs.js"></script>
<script type="text/javascript">
\$(function() {
    // jQuery Upload Thumbs 
    \$('#upload1').uploadThumbs({
        position : '#preview1',   // any: arbitrarily jquery selector
    });
    \$('#upload2').uploadThumbs({
        position : '#preview2',   // any: arbitrarily jquery selector
    });
    \$('#upload3').uploadThumbs({
        position : '#preview3',   // any: arbitrarily jquery selector
    });
    \$('#upload4').uploadThumbs({
        position : '#preview4',   // any: arbitrarily jquery selector
    });
    \$('#upload5').uploadThumbs({
        position : '#preview5',   // any: arbitrarily jquery selector
    });
});
</script>
EOM

	if ($js eq 'js') {
		print <<EOM;
<script>
// referer: http://5am.jp/javascript/form_change_javascript/
function entryChange1(){
	radio = document.getElementsByName('clip');
	if(radio[0].checked) {
		//フォーム
		document.getElementById('ibox').style.display = "";
		document.getElementById('ybox').style.display = "none";
	}else if(radio[1].checked) {
		//フォーム
		document.getElementById('ibox').style.display = "none";
		document.getElementById('ybox').style.display = "";
	}
}
//オンロードさせ、リロード時に選択を保持
window.onload = entryChange1;
</script>
EOM
	}
	
	print <<EOM;
<title>$ttl</title>
</head>
<body>
<div id="head">
	<img src="$cf{cmnurl}/star.png" alt="star" class="icon">
	$cf{bbs_title} 管理画面 ::
</div>
EOM
}

#-----------------------------------------------------------
#  ファイル容量
#-----------------------------------------------------------
sub get_size {
	my $file = shift;
	
	my $size = -s $file || 0;
	return $size > 1024000 ? comma(int($size/1024000)) . 'MB' : $size > 1024 ? comma(int($size/1024)) . 'KB' : $size . 'Bytes';
}

#-----------------------------------------------------------
#  桁区切り
#-----------------------------------------------------------
sub comma {
	local($_) = @_;

	1 while s/(.*\d)(\d\d\d)/$1,$2/;
	$_;
}

#-----------------------------------------------------------
#  エラー
#-----------------------------------------------------------
sub error {
	my $err = shift;
	
	header("ERROR!");
	print <<EOM;
<div id="main">
<div align="center">
<hr width="350">
<h3>ERROR!</h3>
<p class="err">$err</p>
<hr width="350">
<p><input type="button" value="前画面に戻る" onclick="history.back()"></p>
</div></div>
</body>
</html>
EOM
	# フッタ
	footer();

	exit;
}

#-----------------------------------------------------------
#  完了メッセージ
#-----------------------------------------------------------
sub message {
	my $msg = shift;
	
	header("完了");
	print <<EOM;
<div id="main">
<div align="center" style="margin-top:3em;">
<hr width="350">
<p class="msg">$msg</p>
<hr width="350">
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="submit" value="管理画面に戻る">
</form>
</div></div>
</body>
</html>
EOM
	# フッタ
	footer();

	exit;
}

#-----------------------------------------------------------
#  戻りボタン
#-----------------------------------------------------------
sub back_btn {
	my $mode = shift;
	
	print <<EOM;
<div id="body">
<div class="ta-r">
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
@{[ $mode ? qq|<input type="submit" name="$mode" value="&lt; 前画面">| : "" ]}
<input type="submit" value="&lt; メニュー">
</form>
</div>
EOM
}

#-----------------------------------------------------------
#  入力チェック
#-----------------------------------------------------------
sub input_check {
	my $err;

	if (!$in{sub}) { $err .= "タイトルが未入力です<br>"; }
	if (!$in{comment}) { $err .= "メッセージが未入力です<br>"; }
	error($err) if ($err);
}

#-----------------------------------------------------------
#  フッター
#-----------------------------------------------------------
sub footer {
	my $foot = shift;

	# 著作権表記（削除・改変禁止）
	my $copy = <<EOM;
<div id="footer">
	- <a href="https://www.kent-web.com/bbs/topics/topics.cgi" target="_top">TopicsBoard</a> -<br>
	- <a href="https://www.transformsite.com/" target="_top">$cf{version}</a> -<br />
	++ <a href="https://www.transformsite.com/" target="_top">Edited by TRANSFORM</a> ++
</div>
EOM

	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		print "$1$copy$2\n";
	} else {
		print "$foot$copy\n";
		print "</body></html>\n";
	}
	exit;
}


#-----------------------------------------------------------
#  文字カット for UTF-8
#  [quote] http://linkage.white-void.net/development/server/perl-utf8-strcut.html
#-----------------------------------------------------------
sub strcutbytes_utf8 {
	my ($src,$maxlen) = @_;
	$src =~ s/[\t\n]//g;
	$src =~ s/&lt;.*?&gt;//g;
	
	my $srclen = length($src);
	my $srcpos = 0;
	while($srcpos < $srclen) {
		my $character = substr($src, $srcpos, 1);
		my $value = ord($character);
		if($value < 0x80) { # ASCII characters
			$srcpos++;
			next;
		}
		my $width = 6;
		$width = 5 if ($value < 0xFC);
		$width = 4 if ($value < 0xF8);
		$width = 3 if ($value < 0xF0);
		$width = 2 if ($value < 0xE0);
		my $nextpos = $srcpos + $width;
		last if($nextpos > $maxlen);
		last if($nextpos > $srclen); # sequence is incomplete
		$srcpos = $nextpos;
	}
	return substr($src, 0, $srcpos);
}

