# モジュール宣言/変数初期化
use strict;
my %cf;
#┌─────────────────────────────────
#│ TOPICS BOARD v5.3 : init.cgi - 2021/02/13
#│ copyright (c) kentweb, 1997-2022
#│ https://www.kent-web.com/
#└─────────────────────────────────
$cf{version} = 'NEWS BOOK v1.5';
#┌─────────────────────────────────
#│ [注意事項]
#│ 1. このプログラムはフリーソフトです。このプログラムを使用した
#│    いかなる損害に対して作者は一切の責任を負いません。
#│ 2. 設置に関する質問はサポート掲示板にお願いいたします。
#│    直接メールによる質問は一切お受けいたしておりません。
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  NEWS BOOK v1.5 : init.cgi - 2023/08/06
#│  Edited by TRANSFORM Since 2012
#│  https://www.transformsite.com/
#└─────────────────────────────────

#===========================================================
# ■ 設定項目
#===========================================================

# パスワード制限をする場合入室パスワード設定
# → 空欄の場合はパスワード制限なし
$cf{enter_pwd} = '0123';

# パスワード制限時のセッションの許容時間（分単位）
# → 入室後からアクセス可能時間
$cf{sestime} = 60;

# サムネイル画像を作成する（要：Image::Magick）
# → 縮小画像を自動生成し、画像記事の表示速度を軽くする機能
# 0=no 1=yes
$cf{thumbnail} = 1;

# 掲示板タイトル
$cf{bbs_title} = "News & Topics";

# 掲示板プログラムURL【URLパス】
$cf{bbs_cgi} = './';

# 管理プログラムURL【URLパス】
$cf{admin_cgi} = './admin.cgi';

# コメント投稿プログラムURL【URLパス】
$cf{compost_cgi} = './compost.cgi';

# イメージ登録プログラムURL【URLパス】
$cf{upload_cgi} = './upload.cgi';

# データディレクトリ【サーバパス】
$cf{datadir} = './data';

# テンプレートディレクトリ【サーバパス】
$cf{tmpldir} = './tmpl';

# アップディレクトリ【サーバパス】
$cf{upldir} = './upl';

# アップディレクトリ【URLパス】
$cf{uplurl} = './upl';

# 登録イメージ保存ディレクトリ【サーバパス】
$cf{imgdir} = './img';

# 登録イメージ保存ディレクトリ【URLパス】
$cf{imgurl} = './img';

# 共通ディレクトリ【URLパス】
$cf{cmnurl} = './cmn';

# アイコンディレクトリ【URLパス】
$cf{iconurl} = './cmn/icon';

# セッションファイル【サーバパス】
$cf{sesfile} = './data/ses.cgi';

# プロフィール機能ON/OFF
# → 0=no  1=yes
$cf{prof} = 1;

# 週表示
$cf{week} = ['日','月','火','水','木','金','土'];

# 添付ファイルアイコン定義
# → 拡張子とファイル名のペア
$cf{icons} = {
	'.pdf'  => 'pdf.png',
	'.doc'  => 'word.png',
	'.docx' => 'Word-icon.png',
	'.xls'  => 'excel.png',
	'.xlsx' => 'Excel-icon.png',
	'.ppt'  => 'ppt.png',
	'.pptx' => 'powerpoint.png',
	'.txt'  => 'text.png',
	'.zip'  => 'zip.png',
	'.mp3'  => 'mp3.png',
	'.mp4'  => 'mp4.png',
	};

# 添付ファイルアイコンディレクトリ【URLパス】
$cf{icourl} = './cmn/ico';

# -------------------------------------------------------------- #
# [ ココから「コメント返信」機能関連の設定 ]
#
# コメント承認制 (0=no 1=yes)
# → 投稿記事を管理者が表示前に確認する場合（スパム対策）
$cf{approve} = 0;

# コメント返信採番ファイル【サーバパス】
$cf{resnum} = './data/resno.dat';

# TOP用採番ファイル【サーバパス】
$cf{rescnt} = './data/res_cnt.dat';

# コメント返信ログファイル名【サーバパス】
$cf{reslog} = './data/reslog.cgi';

# 最大コメント数 
# サンプルのため、少なく設定されているので、必ず修正する事！
$cf{max_res} = 5;

# アップロードディレクトリ【サーバパス】
$cf{r_upldir} = "./resupl";

# アップロードディレクトリ【URLパス】
$cf{r_uplurl} = "./resupl";

# コメント返信：画像ファイルの最大表示の大きさ（単位：ピクセル）
# → これを超える画像は縮小表示します
$cf{r_max_img_w} = 200;	# 横幅
$cf{r_max_img_h} = 120;	# 縦幅

# コメント返信暗証キー入力フォーム：画像ファイルの最大表示の大きさ（単位：ピクセル）
# → これを超える画像は縮小表示します
$cf{pw_max_img_w} = 80;	# 横幅
$cf{pw_max_img_h} = 55;	# 縦幅

# １ページあたりのコメント検索記事表示件数
$cf{max_resfind} = 5;

# コメント返信メール通知機能
# → 0=no  1=yes
$cf{res_mailing} = 1;

# メール通知先アドレス（メール通知する場合）
$cf{mailto_r} = 'xxx@xxxx.xxx';

# アイコン画像【URLパス】
# → [コメントアイコン]
$cf{ico_com} = "./cmn/icon/comment.png";

# コメント禁止ワードチェック
# → 投稿時禁止するワードをコンマで区切る
$cf{bad_word} = '';

# コメント日本語チェック（コメント内に日本語が含まれていなければ拒否）
# 0=no  1=yes
$cf{jp_word_chk} = 1;

# コメントアクセス制限（半角スペースで区切る、アスタリスク可）
# → 拒否ホスト名を記述（後方一致）【例】*.anonymizer.com
$cf{bad_host} = '';

# コメント承認ログディレクトリ【サーバパス】
$cf{logdir} = './data/approve';

# sendmailのパス（メール通知する場合）
$cf{sendmail} = '/usr/lib/sendmail';

# sendmailの -fコマンドが必要な場合
# 0=no 1=yes
$cf{sendm_f} = 0;

# -------------------------------------------------------------- #
# [ ココまで「コメント返信」機能関連の設定 ]

# 投稿受理最大サイズ (bytes)
# → 例 : 102400 = 100KB
$cf{maxdata} = 307200000;

# アップロードを許可するファイル（0=no 1=yes）
$cf{ok_text}  = 0;  # TEXT
$cf{ok_gif}   = 1;  # GIF
$cf{ok_jpeg}  = 1;  # JPEG
$cf{ok_png}   = 1;  # PNG
$cf{ok_excel} = 1;  # EXCEL
$cf{ok_word}  = 1;  # WORD
$cf{ok_ppt}   = 1;  # POWER POINT
$cf{ok_zip}   = 1;  # ZIP
$cf{ok_pdf}   = 1;  # PDF
$cf{ok_mp3}   = 1;  # mp3
$cf{ok_mp4}   = 1;  # MP4

# カレンダーの祝日色指定
$cf{week_col} = '#b3e7ff';

# 画像ファイルの最大表示の大きさ（単位：ピクセル）
# → これを超える画像は縮小表示します
$cf{max_img_w} = 300;	# 横幅
$cf{max_img_h} = 150;	# 縦幅

# １ページ当たりの記事表示数
# → 順に、親記事、コメント検索、管理モード{記事メンテナンス} 登録画像表示数
$cf{pg_max} = 5;
$cf{max_find} = 5;
$cf{max_resfind} = 5;
$cf{list_max} = 30;

# サイドMENU内「最新記事TOP(リンク数)」に掲載するタイトルリンクの数
$cf{max_topics} = 7;

# サイドMENU内「最新コメントTOP(リンク数)」に掲載するタイトルリンクの数
$cf{max_com} = 10;

# URLの自動リンク (0=no 1=yes)
$cf{autolink} = 1;

# 最大記事数
# → これを超える記事は古い順に自動削除されます
$cf{max} = 200;

# 戻り先のURL【URLパス】
$cf{homepage} = "../index.html";

# クッキーID名（特に変更しなくてよい）
# → クッキー保存名
$cf{cookie_id} = "newsbook";
$cf{cookie_id3} = "news_pwd";

# 管理パスワードの最大間違い制限
# → この回数以上パスワードを間違うとロックします
$cf{max_failpass} = 5;

# 管理パスワードのロック期間：自動解除を日数で指定
# → この値を 0 にすると自動解除しません。
$cf{lock_days} = 14;

# -------------------------------------------------------------- #
# [ 以下は「画像認証機能」機能（スパム対策）を使用する場合の設定 ]
#
# 画像認証機能の使用
# 0 : しない
# 1 : ライブラリ版（pngren.pl）
# 2 : モジュール版（GD::SecurityImage + Image::Magick）→ Image::Magick必須
$cf{use_captcha} = 1;

# 認証用画像生成ファイル【URLパス】
$cf{captcha_cgi} = './captcha.cgi';

# 画像認証プログラム【サーバパス】
$cf{captcha_pl} = './lib/captcha.pl';
$cf{captsec_pl} = './lib/captsec.pl';
$cf{pngren_pl}  = './lib/pngren.pl';

# 画像認証機能用暗号化キー（暗号化/復号化をするためのキー）
# → 適当に変更してください。
$cf{captcha_key} = 'captclipbbs';

# 投稿キー許容時間（分単位）
# → 投稿フォーム表示後、送信ボタンが押されるまでの可能時間。
$cf{cap_time} = 30;

# 投稿キーの文字数
# ライブラリ版 : 4～8文字で設定
# モジュール版 : 6～8文字で設定
$cf{cap_len} = 6;

# 画像/フォント格納ディレクトリ【サーバパス】
$cf{bin_dir} = './lib/bin';

# [ライブラリ版] 画像ファイル [ ファイル名のみ ]
$cf{si_png} = "spectrum_blue.png";

# [モジュール版] 画像フォント [ ファイル名のみ ]
$cf{font_ttl} = "tempest.ttf";

#===========================================================
# ■ 設定完了
#===========================================================

# 設定内容を返す
sub set_init { return %cf; }

#-----------------------------------------------------------
#  フォームデコード
#-----------------------------------------------------------
sub parse_form {
	my $cgi = shift;
	
	my %in;
	for ( $cgi->param() ) {
		my $val = $cgi->param($_);
		
		if (!/^upfile\d$/) {
			# 無効化
			$val =~ s/&/&amp;/g;
			$val =~ s/</&lt;/g;
			$val =~ s/>/&gt;/g;
			$val =~ s/"/&quot;/g;
			$val =~ s/'/&#39;/g;
			
			# 改行変換
			$val =~ s/\r\n/\t/g;
			$val =~ s/\n/\t/g;
			$val =~ s/\r/\t/g;
		}
		$in{$_} = $val;
	}
	return %in;
}

#-----------------------------------------------------------
#  月の末日
#-----------------------------------------------------------
sub last_day {
	my ($yy,$mm) = @_;
	
	return (31,28,31,30,31,30,31,31,30,31,30,31) [$mm - 1]
		+ ($mm == 2 && (($yy % 4 == 0 && $yy % 100 != 0) || $yy % 400 == 0));
}

#-----------------------------------------------------------
#  週算出
#-----------------------------------------------------------
sub get_week {
	my ($yy,$mm,$dd) = @_;
	
	if ($mm == 1 || $mm == 2) {
		$yy--;
		$mm += 12;
	}
	int( $yy + int($yy / 4) - int($yy / 100) + int($yy / 400) + int((13 * $mm + 8) / 5) + $dd ) % 7;
}

#-----------------------------------------------------------
#  画像リサイズ
#-----------------------------------------------------------
sub resize {
	my ($w,$h) = @_;
	
	# 画像表示縮小
	if ($w > $cf{max_img_w} || $h > $cf{max_img_h}) {
		my $w2 = $cf{max_img_w} / $w;
		my $h2 = $cf{max_img_h} / $h;
		my $key;
		if ($w2 < $h2) { $key = $w2; } else { $key = $h2; }
		$w = int ($w * $key) || 1;
		$h = int ($h * $key) || 1;
	}
	return ($w,$h);
}

#-----------------------------------------------------------
#  コメント返信：画像リサイズ
#-----------------------------------------------------------
sub resize_res {
	my ($w,$h) = @_;

	# 画像表示縮小
	if ($w > $cf{r_max_img_w} || $h > $cf{r_max_img_h}) {
		my $w2 = $cf{r_max_img_w} / $w;
		my $h2 = $cf{r_max_img_h} / $h;
		my $key;
		if ($w2 < $h2) { $key = $w2; } else { $key = $h2; }
		$w = int ($w * $key) || 1;
		$h = int ($h * $key) || 1;
	}

	return ($w,$h);
}

#-----------------------------------------------------------
#  コメント返信暗証キー入力フォーム：画像リサイズ
#-----------------------------------------------------------
sub resize_pwd {
	my ($w,$h) = @_;

	# 画像表示縮小
	if ($w > $cf{pw_max_img_w} || $h > $cf{pw_max_img_h}) {
		my $w2 = $cf{pw_max_img_w} / $w;
		my $h2 = $cf{pw_max_img_h} / $h;
		my $key;
		if ($w2 < $h2) { $key = $w2; } else { $key = $h2; }
		$w = int ($w * $key) || 1;
		$h = int ($h * $key) || 1;
	}

	return ($w,$h);
}

#-----------------------------------------------------------
#  パスワード制限
#-----------------------------------------------------------
sub passwd {
	my %in = @_;

	# 入室フォーム指定のとき
	if ($in{mode} eq 'enter') { pwd_form(); }

	# 時間取得
	my $now = time;

	# ログインのとき
	if ($in{login}) {
		# 認証
		if ($in{pw} ne $cf{enter_pwd}) { error("認証できません"); }

		# セッション発行
		my @wd = (0 .. 9, 'a' .. 'z', 'A' .. 'Z', '_');
		my $ses;
		srand;
		for (1 .. 25) {	$ses .= $wd[int(rand(@wd))]; }

		# セッション更新
		my @log;
		open(DAT,"+< $cf{sesfile}") or error("write err: $cf{sesfile}");
		eval 'flock(DAT, 2);';
		while(<DAT>) {
			chomp;
			my ($id,$time) = split(/\t/);
			next if ($now - $time > $cf{sestime} * 60);

			push(@log,"$_\n");
		}
		unshift(@log,"$ses\t$now\n");
		seek(DAT, 0, 0);
		print DAT @log;
		truncate(DAT, tell(DAT));
		close(DAT);

		# クッキー格納
		print "Set-Cookie: $cf{cookie_id3}=$ses\n";

	# セッション確認
	} else {

		# クッキー取得
		my $cook = $ENV{HTTP_COOKIE};

		# 該当IDを取り出す
		my %cook;
		foreach ( split(/;/, $cook) ) {
			my ($key,$val) = split(/=/);
			$key =~ s/\s//g;
			$cook{$key} = $val;
		}

		# クッキーなし
		if ($cook{$cf{cookie_id3}} eq '') { &pwd_form; }

		# ログオフのとき
		if ($in{mode} eq 'logoff') {

			my @log;
			open(DAT,"+< $cf{sesfile}") or error("write err: $cf{sesfile}");
			eval 'flock(DAT, 2);';
			while(<DAT>) {
				my ($id,undef) = split(/\t/);
				next if ($cook{$cf{cookie_id3}} eq $id);

				push(@log,$_);
			}
			seek(DAT, 0, 0);
			print DAT @log;
			truncate(DAT, tell(DAT));
			close(DAT);

			if ($ENV{PERLXS} eq "PerlIS") {
				print "HTTP/1.0 302 Temporary Redirection\r\n";
				print "Content-type: text/html\n";
			}
			print "Set-Cookie: $cf{cookie_id3}=;\n";
			print "Location: $cf{homepage}\n\n";
			exit;
		}

		# セッションチェック
		my $flg;
		open(DAT,"$cf{sesfile}") or error("open err: $cf{sesfile}");
		while(<DAT>) {
			chomp;
			my ($id,$time) = split(/\t/);

			if ($cook{$cf{cookie_id3}} eq $id) {
				# 時間オーバー
				if ($now - $time > $cf{sestime} * 60) {
					$flg = -1;
				# OK
				} else {
					$flg = 1;
				}
				last;
			}
		}
		close(DAT);

		# 時間オーバー
		if ($flg == -1) {
			my $msg = qq|入室時間が経過しました。再度ログインしてください<br>\n|;
			$msg .= qq|[<a href="$cf{bbs_cgi}?mode=enter">ログイン</a>]\n|;
			&error($msg);

		# セッション情報なし
		} elsif (!$flg) {
			pwd_form();
		}
	}
}

#-----------------------------------------------------------
#  入室画面
#-----------------------------------------------------------
sub pwd_form {
	open(IN,"$cf{tmpldir}/enter.html") or error('open err: enter.html');
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/style.css|g;

	print "Content-type: text/html; charset=utf-8\n\n";
	footer($tmpl);
}

#-----------------------------------------------------------
#  プロフィール認識
#-----------------------------------------------------------
sub read_profile {
	my %set;
	open(IN,"$cf{datadir}/profile.dat") or error("open err: profile.dat");
	while(<IN>) {
		chomp;
		my ($key,$val) = split(/<>/);
		
		$set{$key} = $val;
	}
	close(IN);
	
	return %set;
}

1;

